'*******************************************************************************
'CronEdit v1.3.1
'********************************************************************************
'2006.10.02
'
'http://supware.net
'doug@supware.net
'
'Copyright (C) 2006 Doug Melton
'
'This program is free software; you can redistribute it and/or
'modify it under the terms of the GNU General Public License
'as published by the Free Software Foundation; either version 2
'of the License, or (at your option) any later version.
'
'This program is distributed in the hope that it will be useful,
'but WITHOUT ANY WARRANTY; without even the implied warranty of
'MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'GNU General Public License for more details.
'
'You should have received a copy of the GNU General Public License
'along with this program; if not, write to the Free Software
'Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
'******************************************************************************

Public Class frmTaskEdit
    Inherits System.Windows.Forms.Form
    Friend WithEvents lblTaskName As System.Windows.Forms.Label
    Friend WithEvents txtTaskName As System.Windows.Forms.TextBox
    Friend WithEvents lblFrequency As System.Windows.Forms.Label
    Friend WithEvents cboFrequency As System.Windows.Forms.ComboBox

    'create an open file dialog
    'Shared ofd As SmartphoneDialogs.OpenNETCF.Windows.Forms.OpenFileDialog = New SmartphoneDialogs.OpenNETCF.Windows.Forms.OpenFileDialog
    Shared ofd As OpenDialog = New OpenDialog

#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()
    End Sub

    Public Sub New(ByRef ct As CronTask)
        MyBase.New()

        InitializeComponent()

        'Add any initialization after the InitializeComponent() call
        Me.txtTaskName.Text = ct.getTaskName
        If ct.minute = -1 Then
            Me.cboFrequency.Text = ""
        ElseIf ct.hour = -1 Then
            Me.cboFrequency.Text = "Hourly"
        ElseIf ct.mday = -1 And ct.wday = -1 Then
            Me.cboFrequency.Text = "Daily"
        ElseIf ct.mday = -1 Then
            Me.cboFrequency.Text = "Weekly"
        ElseIf ct.month = -1 Then
            Me.cboFrequency.Text = "Monthly"
        Else
            Me.cboFrequency.Text = ""
        End If
        If ct.hour = -1 Then
            Me.txtHour.Text = "00"
        Else
            Me.txtHour.Text = Format(ct.hour, "00")
        End If
        If ct.minute = -1 Then
            Me.txtMinute.Text = "00"
        Else
            Me.txtMinute.Text = Format(ct.minute, "00")
        End If
        If ct.wday = -1 Then
            Me.cboWday.Text = ""
        Else
            Me.cboWday.SelectedIndex = ct.wday - 1
        End If
        If ct.mday = -1 Then
            Me.cboMday.Text = ""
        Else
            Me.cboMday.SelectedIndex = ct.mday - 1
        End If
    End Sub

    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        MyBase.Dispose(disposing)
    End Sub

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    Friend WithEvents MainMenu1 As System.Windows.Forms.MainMenu
    Friend WithEvents MenuItem1 As System.Windows.Forms.MenuItem
    Friend WithEvents MenuItem2 As System.Windows.Forms.MenuItem
    Friend WithEvents MenuItem3 As System.Windows.Forms.MenuItem

    Friend WithEvents lblStartTime As System.Windows.Forms.Label
    Friend WithEvents txtHour As System.Windows.Forms.TextBox
    Friend WithEvents lblColon As System.Windows.Forms.Label
    Friend WithEvents txtMinute As System.Windows.Forms.TextBox

    Friend WithEvents lblDay As System.Windows.Forms.Label
    Friend WithEvents cboWday As System.Windows.Forms.ComboBox
    Friend WithEvents cboMday As System.Windows.Forms.ComboBox
    Friend WithEvents MenuItem4 As System.Windows.Forms.MenuItem
    Friend WithEvents mnuCancel As System.Windows.Forms.MenuItem

    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.MainMenu1 = New System.Windows.Forms.MainMenu
        Me.MenuItem1 = New System.Windows.Forms.MenuItem
        Me.MenuItem2 = New System.Windows.Forms.MenuItem
        Me.MenuItem3 = New System.Windows.Forms.MenuItem
        Me.MenuItem4 = New System.Windows.Forms.MenuItem
        Me.mnuCancel = New System.Windows.Forms.MenuItem
        Me.lblTaskName = New System.Windows.Forms.Label
        Me.txtTaskName = New System.Windows.Forms.TextBox
        Me.lblFrequency = New System.Windows.Forms.Label
        Me.cboFrequency = New System.Windows.Forms.ComboBox
        Me.lblStartTime = New System.Windows.Forms.Label
        Me.txtHour = New System.Windows.Forms.TextBox
        Me.lblColon = New System.Windows.Forms.Label
        Me.txtMinute = New System.Windows.Forms.TextBox
        Me.lblDay = New System.Windows.Forms.Label
        Me.cboWday = New System.Windows.Forms.ComboBox
        Me.cboMday = New System.Windows.Forms.ComboBox
        '
        'MainMenu1
        '
        Me.MainMenu1.MenuItems.Add(Me.MenuItem1)
        Me.MainMenu1.MenuItems.Add(Me.MenuItem2)
        '
        'MenuItem1
        '
        Me.MenuItem1.Text = "OK"
        '
        'MenuItem2
        '
        Me.MenuItem2.MenuItems.Add(Me.MenuItem3)
        Me.MenuItem2.MenuItems.Add(Me.MenuItem4)
        Me.MenuItem2.MenuItems.Add(Me.mnuCancel)
        Me.MenuItem2.Text = "Options"
        '
        'MenuItem3
        '
        Me.MenuItem3.Text = "Change Task"
        '
        'MenuItem4
        '
        Me.MenuItem4.Text = "-"
        '
        'mnuCancel
        '
        Me.mnuCancel.Text = "Cancel"
        '
        'lblTaskName
        '
        Me.lblTaskName.Size = New System.Drawing.Size(176, 22)
        Me.lblTaskName.Text = "Task Name"
        '
        'txtTaskName
        '
        Me.txtTaskName.Location = New System.Drawing.Point(0, 24)
        Me.txtTaskName.Multiline = True
        Me.txtTaskName.Size = New System.Drawing.Size(136, 56)
        Me.txtTaskName.Text = ""
        '
        'lblFrequency
        '
        Me.lblFrequency.Location = New System.Drawing.Point(0, 88)
        Me.lblFrequency.Size = New System.Drawing.Size(80, 22)
        Me.lblFrequency.Text = "Frequency"
        '
        'cboFrequency
        '
        Me.cboFrequency.Items.Add("Hourly")
        Me.cboFrequency.Items.Add("Daily")
        Me.cboFrequency.Items.Add("Weekly")
        Me.cboFrequency.Items.Add("Monthly")
        Me.cboFrequency.Location = New System.Drawing.Point(80, 88)
        Me.cboFrequency.Size = New System.Drawing.Size(96, 26)
        '
        'lblStartTime
        '
        Me.lblStartTime.Location = New System.Drawing.Point(0, 120)
        Me.lblStartTime.Size = New System.Drawing.Size(80, 22)
        Me.lblStartTime.Text = "Start Time"
        '
        'txtHour
        '
        Me.txtHour.Location = New System.Drawing.Point(80, 120)
        Me.txtHour.Size = New System.Drawing.Size(24, 25)
        Me.txtHour.Text = "00"
        '
        'lblColon
        '
        Me.lblColon.Location = New System.Drawing.Point(104, 120)
        Me.lblColon.Size = New System.Drawing.Size(8, 24)
        Me.lblColon.Text = ":"
        '
        'txtMinute
        '
        Me.txtMinute.Location = New System.Drawing.Point(112, 120)
        Me.txtMinute.Size = New System.Drawing.Size(24, 25)
        Me.txtMinute.Text = "00"
        '
        'lblDay
        '
        Me.lblDay.Location = New System.Drawing.Point(0, 152)
        Me.lblDay.Size = New System.Drawing.Size(80, 22)
        Me.lblDay.Text = "Month Day"
        '
        'cboWday
        '
        Me.cboWday.Items.Add("Monday")
        Me.cboWday.Items.Add("Tuesday")
        Me.cboWday.Items.Add("Wednesday")
        Me.cboWday.Items.Add("Thursday")
        Me.cboWday.Items.Add("Friday")
        Me.cboWday.Items.Add("Saturday")
        Me.cboWday.Items.Add("Sunday")
        Me.cboWday.Location = New System.Drawing.Point(80, 152)
        Me.cboWday.Size = New System.Drawing.Size(96, 26)
        '
        'cboMday
        '
        Me.cboMday.Items.Add("1")
        Me.cboMday.Items.Add("2")
        Me.cboMday.Items.Add("3")
        Me.cboMday.Items.Add("4")
        Me.cboMday.Items.Add("5")
        Me.cboMday.Items.Add("6")
        Me.cboMday.Items.Add("7")
        Me.cboMday.Items.Add("8")
        Me.cboMday.Items.Add("9")
        Me.cboMday.Items.Add("10")
        Me.cboMday.Items.Add("11")
        Me.cboMday.Items.Add("12")
        Me.cboMday.Items.Add("13")
        Me.cboMday.Items.Add("14")
        Me.cboMday.Items.Add("15")
        Me.cboMday.Items.Add("16")
        Me.cboMday.Items.Add("17")
        Me.cboMday.Items.Add("18")
        Me.cboMday.Items.Add("19")
        Me.cboMday.Items.Add("20")
        Me.cboMday.Items.Add("21")
        Me.cboMday.Items.Add("22")
        Me.cboMday.Items.Add("23")
        Me.cboMday.Items.Add("24")
        Me.cboMday.Items.Add("25")
        Me.cboMday.Items.Add("26")
        Me.cboMday.Items.Add("27")
        Me.cboMday.Items.Add("28")
        Me.cboMday.Items.Add("29")
        Me.cboMday.Items.Add("30")
        Me.cboMday.Items.Add("31")
        Me.cboMday.Location = New System.Drawing.Point(80, 176)
        Me.cboMday.Size = New System.Drawing.Size(96, 26)
        Me.cboMday.Visible = False
        '
        'frmTaskEdit
        '
        Me.ClientSize = New System.Drawing.Size(176, 208)
        Me.Controls.Add(Me.lblTaskName)
        Me.Controls.Add(Me.txtTaskName)
        Me.Controls.Add(Me.lblFrequency)
        Me.Controls.Add(Me.cboFrequency)
        Me.Controls.Add(Me.lblStartTime)
        Me.Controls.Add(Me.txtHour)
        Me.Controls.Add(Me.lblColon)
        Me.Controls.Add(Me.txtMinute)
        Me.Controls.Add(Me.lblDay)
        Me.Controls.Add(Me.cboMday)
        Me.Controls.Add(Me.cboWday)
        Me.Menu = Me.MainMenu1
        Me.Text = "CronEdit"

    End Sub

#End Region

    Private Sub MenuItem1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuItem1.Click
        Me.DialogResult = DialogResult.OK
    End Sub

    Private Sub mnuCancel_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuCancel.Click
        Me.DialogResult = DialogResult.Cancel
    End Sub


    Private Sub MenuItem3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuItem3.Click
        ofd.Reset()

        'set dialog to display only text files
        ofd.Filter = "All Files|*.*"
        ofd.FilterIndex = 1

        'show dialog to user
        If ofd.ShowDialog() = DialogResult.OK Then
            txtTaskName.Text = ofd.FileName
        End If

        Me.BringToFront()
    End Sub

    Private Sub txtHour_GotFocus(ByVal sender As Object, ByVal e As System.EventArgs) Handles txtHour.GotFocus
        txtHour.Select(0, txtHour.Text.Length)
    End Sub

    Private Sub txtMinute_GotFocus(ByVal sender As Object, ByVal e As System.EventArgs) Handles txtMinute.GotFocus
        txtMinute.Select(0, txtMinute.Text.Length)
    End Sub

    Private Sub cboFrequency_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cboFrequency.SelectedIndexChanged
        If cboFrequency.Text = "Hourly" Or cboFrequency.Text = "Daily" Then
            Me.lblDay.Hide()
            Me.cboWday.Hide()
            Me.cboMday.Hide()
        ElseIf cboFrequency.Text = "Weekly" Then
            Me.lblDay.Text = "Week Day"
            Me.lblDay.Show()
            Me.cboMday.Hide()
            Me.cboWday.Top = 152
            Me.cboWday.Show()
        ElseIf cboFrequency.Text = "Monthly" Then
            Me.lblDay.Text = "Month Day"
            Me.lblDay.Show()
            Me.cboWday.Hide()
            Me.cboMday.Top = 152
            Me.cboMday.Show()
        End If
    End Sub

    Private Sub frmTaskEdit_Resize(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Resize
        Me.txtTaskName.Width = Me.ClientSize.Width
    End Sub
End Class
